 
  DROP FUNCTION co_sys_example_association_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_sys_example_association_check_acl(int,int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sys_acl WHERE area = \'sys\' AND class_name = \'example_association\' AND id_object = $1 AND id_permission = $2 AND id_role = $3 ;
' LANGUAGE 'sql' 
!GO 
  
  DROP FUNCTION co_sys_example_association_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_sys_example_association_check_acl_class(int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sys_acl_class WHERE area = \'sys\' AND class_name = \'example_association\' AND id_permission = $1 AND id_role = $2 ; 
 
 ' LANGUAGE 'sql'   
    !GO 
  
     DROP FUNCTION lhlo_sys_example_association_id(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_id(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."id" = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_example_association_version(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_version(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."version" = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_example_association_deleted(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_deleted(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."deleted" = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_example_association_inherits_acl(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_inherits_acl(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."inherits_acl" = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_example_association_id_foreign1(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_id_foreign1(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."id_foreign1" = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_example_association_id_foreign2(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_example_association_id_foreign2(int) RETURNS co_sys_example_association AS
     '
        SELECT * FROM co_sys_example_association WHERE co_sys_example_association."id_foreign2" = $1
     '
     LANGUAGE 'sql'
     !GO
       