 
type CO_INDEX
 {
   c_type int;
   sql_type int;
   js_type Number;
   pointer 0;
   is_array 0;
 };
	      
type CO_INTEGER
 {
   c_type int;
   sql_type int;
   js_type Number;
   pointer 0;
   is_array 0;
 };
	      
type CO_STRING
 {
   c_type "const char*";
   sql_type text;
   js_type String;
   pointer 1;
   is_array 0;
 };
 
type CO_POINTER
 {
   c_type "void *";
   sql_type ****WRONG****;
   js_type ****WRONG****;
   pointer 1;
   is_array 0;
 };
 
type CO_ARRAY_OF_STRINGS
 {
   c_type "co_array_of_pointers *";
   sql_type ****WRONG****;
   js_type '';
   pointer 1;
   is_array 1;
 };    
			  
type CO_STRING_SQL_VALUE
 {
   c_type "const char*";
   sql_type ****WRONG****;    
   js_type String;
   pointer 1;
   is_array 0;
 };

type CO_BOOL
 {
   c_type bool;
   sql_type bool;
   js_type Boolean;
   pointer 0;
   is_array 0;
 };

type CO_DATE
 {
  c_type "const char*";
  sql_type date;
  js_type Date;
  pointer 1;
  is_array 0;
 };

type CO_TIME
 {
  c_type "const char*";
  sql_type time;
  js_type Date;
  pointer 1;
  is_array 0;
 };
 
type CO_TIMESTAMP
 {
  c_type "const char*";
  sql_type timestamp;
  js_type Date;
  pointer 1;
  is_array 0;
 };

type CO_REAL
 {
  c_type float; 
  sql_type float4; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

type CO_NUMERIC
 {
  c_type float; 
  sql_type numeric; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

type CO_MONEY
 {
  c_type float; 
  sql_type 'numeric(30,2)';
  js_type Number; 
  pointer 0;
  is_array 0;
 };


//#define __PARAMS_HEADER_2D param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };




//#define __PARAMS_HEADER_2D_WITH_CALLBACK __PARAMS_HEADER_2D param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";};
























class example_association
{
   area "sys";

   container_class '';
   container_column_name '';   


 f_check_acl_class 
    %%
      @ "SELECT 1 FROM co_sys_acl_class WHERE area = \\'$name_area\\' AND class_name = \\'$name_class\\' AND id_permission = \$1 AND id_role = \$2 ; \n"
    %%
    ;
 f_check_acl 
    %%
      @ "SELECT 1 FROM co_sys_acl WHERE area = \\'$name_area\\' AND class_name = \\'$name_class\\' AND id_object = \$1 AND id_permission = \$2 AND id_role = \$3 ;" 
    %% 
    ;



    
   inherits generic_association;

sequence sqid; 
index inid 
{ 
 unique 1; 
 column id; 
}; 

prop id 
{ 
  type CO_INTEGER; 
  default SEQUENCE { sq_name sqid; }; 
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
};

prop version
{
  type CO_INTEGER;
  default 0;
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
};

prop deleted 
{ 
  type CO_INTEGER;
  default 0;
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
}; 


prop inherits_acl
{
  type CO_INTEGER;
  default 1;
  params 'HIDDEN=1;READONLY=1';
  representant 0;
  foreign '';
  foreign_prop '';
  position 50;
};

      
prop id_foreign1
{
  type CO_INTEGER;
  default 1;
  params 'READONLY=1';
  representant 0;
  foreign 'meta_tree';
  foreign_prop 'id';
  position 100;
};

prop id_foreign2
{
  type CO_INTEGER;
  default 1;
  params 'READONLY=1';
  representant 0;
  foreign 'meta_tree';
  foreign_prop 'id';
  position 150;
};

};  // end of class generic_association
