#include "types.t"
#include "defines.t"

class meta_tree_root
{
	area sys;

	doc
	%%
	This class describes roots for some cross-class trees.
	%%
	;

#include "check_acl.t"
   
   container_class '';
   container_column_name '';

#include "generic_acl_props.t"    

   prop tree_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };
   
   prop root
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 300;
   };

   inherits generic_acl;

   index in1
   {
    unique 0;
    column tree_name;
   };

};  
