# Created automatically from ../../comodules/tools/Jeeves/examples/init_data.tpl
use Ast;
use JeevesUtil;

$tmp_file = "jeeves.tmp";

sub open_file;
if (! (defined ($ROOT) && $ROOT)) {
    die "ROOT not defined";
}

$file = "> -";
open (F, $file) || die $@;
$code = "";
$ROOT->visit();
 use co_modules_functions;
output("\n");
 $user = $ENV{"USER"};
output("\n");
# Line 5
foreach $item_list_i (@${item_list}) {
    $item_list_i->visit ();
output("\n");
# Line 7
foreach $file_i (@${file}) {
    $file_i->visit ();
output("\n");
# Line 9
open_file("co_set_${name_file}.pl", 0, 0, 0);
output("#!/usr/bin/perl\n");
output(" \n");
output("# $Id: init_data.tpl.pl,v 1.1.1.1 2003/04/15 12:46:20 jacek_s Exp $\n");
output(" \n");
output("# Before `make install\' is performed this script should be runnable with\n");
output("# `make test\'. After `make install\' it should work as `perl test.pl\'\n");
output(" \n");
output("######################### We start with some black magic to print on failure.\n");
output(" \n");
output("BEGIN { \$| = 1; }\n");
output("END {print \"test failed\\n\" unless \$loaded;}\n");
output("use Pg;\n");
output("\$loaded = 1;\n");
output("use strict;\n");
output(" \n");
output("######################### End of black magic.\n");
output(" \n");
output("##my \$dbmain = \'nobody\';\n");
output("##my \$dbname = \'nobody\';\n");
output("my \$dbconnstr = \'dbname=nobody\';\n");
output("my \$trace  = \'/tmp/pgtrace.out\';\n");
output("my (\$conn, \$result, \$i, \$last_id);\n");
output(" \n");
output("my \$DEBUG  = 0; # set this to 1 for traces\n");
output("\n");
output("\$SIG{PIPE} = sub { print \"broken pipe\\n\" };\n");
output("\n");
output("\$dbconnstr = \$ARGV[0]; shift;\n");
output(" \n");
output("######################### create and connect to database\n");
output(" \n");
output("my \$Option_ref = Pg::conndefaults();\n");
output("my (\$key, \$val);\n");
output("( \$\$Option_ref{port} ne \"\" && \$\$Option_ref{dbname} ne \"\" && \$\$Option_ref{user} ne \"\" )\n");
output("and print \"Pg::conndefaults ........ ok\\n\"\n");
output("or  die   \"Pg::conndefaults ........ not ok: \", \$conn->errorMessage;\n");
output("	 \n");
output("\$conn = Pg::connectdb(\$dbconnstr);\n");
output("( PGRES_CONNECTION_OK eq \$conn->status )\n");
output("    and print \"Pg::connectdb ........... ok\\n\"\n");
output("    or  die   \"Pg::connectdb ........... not ok: \", \$conn->errorMessage;  \n");
output("\n");
output("		\n");
output("\n");
output("\n");
# Line 55
foreach $class_i (@${class}) {
    $class_i->visit ();
# Line 56
foreach $area_i (@${area}) {
    $area_i->visit ();
output("\n");
output("    # AREA.CLASS $name_area.$name_class \n");
output("    \n");
 # print "###########################################################################################";
 # print "AREA.CLASS $name_area.$name_class ";
 # $class_i->print();
output("    \n");
output("      \$result = \$conn->exec(\"INSERT INTO co_${name_area}_${name_class} (version) VALUES(0)\");    \n");
output("      \$result = \$conn->exec(\"SELECT last_value FROM co_${name_area}_${name_class}_sqid\");\n");
output("      \$last_id = (\$result->fetchrow)[0];\n");
output("\n");
# Line 68
foreach $remove_old_i (@${remove_old}) {
    $remove_old_i->visit ();
output("          \$result = \$conn->exec(\"DELETE FROM co_${name_area}_${name_class} WHERE $name_remove_old\"); \n");
#Line 70
    Ast->bye();
}
output("\n");
# Line 72
foreach $escape_perl_i (@${escape_perl}) {
    $escape_perl_i->visit ();
output("          $name_escape_perl\n");
#Line 74
    Ast->bye();
}
output("        \n");
# Line 76
foreach $p_i (@${p}) {
    $p_i->visit ();
output("      \n");
# Line 78
foreach $val_i (@${val}) {
    $val_i->visit ();
 $name_val =~ s/([\"|\'|\\|\@|\$])/\\\\\\\1/g;
output("          \$result = \$conn->exec(\"UPDATE co_${name_area}_${name_class} SET $name_p=\'$name_val\' WHERE id=\$last_id\"); \n");
output("\n");
 if($name_p eq "id") {
output("             \$last_id = $name_val;\n");
 };
#Line 85
    Ast->bye();
}
output("        \n");
# Line 87
foreach $recent_i (@${recent}) {
    $recent_i->visit ();
output("           \$result = \$conn->exec(\"UPDATE co_${name_area}_${name_class} SET $name_p=(SELECT last_value FROM co_${name_area}_${name_recent}_sqid) WHERE id=\$last_id\"); \n");
#Line 89
    Ast->bye();
}
output("	\n");
# Line 91
foreach $getByName_i (@${getByName}) {
    $getByName_i->visit ();
# Line 92
foreach $f_i (@${f}) {
    $f_i->visit ();
output("            \$result = \$conn->exec(\"UPDATE co_${name_area}_${name_class} SET $name_p=(SELECT id FROM co_${name_area}_${name_getByName} WHERE name = \'${name_f}\') WHERE id=\$last_id\"); \n");
#Line 94
    Ast->bye();
}
#Line 95
    Ast->bye();
}
output("\n");
# Line 97
foreach $getByProp_i (@${getByProp}) {
    $getByProp_i->visit ();
# Line 98
foreach $prop_i (@${prop}) {
    $prop_i->visit ();
# Line 99
foreach $val_i (@${val}) {
    $val_i->visit ();
output("            \$result = \$conn->exec(\"UPDATE co_${name_area}_${name_class} SET $name_p=(SELECT id FROM co_${name_area}_${name_getByProp} WHERE ${name_prop} = \'${name_val}\') WHERE id=\$last_id\"); \n");
#Line 101
    Ast->bye();
}
#Line 102
    Ast->bye();
}
#Line 103
    Ast->bye();
}
output("\n");
output("\n");
# Line 106
foreach $full_control_i (@${full_control}) {
    $full_control_i->visit ();
output("             \$result = \$conn->exec(\"INSERT INTO co_sec_acl \n");
output("                                       SELECT NEXTVAL(\'co_sec_acl_sqid\'),0,0, p.id, \$last_id, r.id, \'$name_area\', \'$name_class\' \n");
output("                                       FROM  co_sec_permission p, co_sec_role r\n");
output("                                       WHERE r.name= \'$name_full_control\' \"); \n");
#Line 111
    Ast->bye();
}
output("        	\n");
#Line 113
    Ast->bye();
}
output("\n");
#Line 115
    Ast->bye();
}
output("\n");
output("\n");
 undef(@${recent});
 undef(@${remove_old});	
 undef(@${escape_perl});	
 undef(@${getByName});
 undef(@${full_control});	
 undef(@${val});	
 undef(@${getByProp});
 undef(@${p});
output("\n");
output("\n");
#Line 128
    Ast->bye();
}
output("\n");
#Line 130
    Ast->bye();
}
#Line 131
    Ast->bye();
}
Ast->bye();
close(F);
unlink ($tmp_file);

sub open_file {
    my ($a_file, $a_nooverwrite, $a_only_if_different, $a_append) = @_;

    #First deal with the file previously opened
    close (F);
    if ($only_if_different) {
        if (JeevesUtil::compare ($orig_file, $curr_file) != 0) {
            rename ($curr_file, $orig_file) || 
            die "Error renaming $curr_file  to $orig_file";
        }
    }

    #Now for the new file ...
    $curr_file = $orig_file = $a_file;
    $only_if_different = ($a_only_if_different && (-f $curr_file)) ? 1 : 0;
    $no_overwrite = ($a_nooverwrite && (-f $curr_file))  ? 1 : 0;
    $mode =  ($a_append) ? ">>" : ">";

    if ($only_if_different) {
        unlink ($tmp_file);
        $curr_file = $tmp_file;
    }

    if (! $no_overwrite) {
        open (F, "$mode $curr_file") || die "could not open $curr_file";
    }
}

sub output {
    print F @_ if (! $no_overwrite) 
}
1;
