/* method: wrapper around PutRequest */
function COMethod( strArea, strClass
, strMethod )
{
  this.strArea = strArea;
  this.strClass = strClass;
  this.strMethod = strMethod;
  this.query = strClass+"?"+strMethod+"&";
  this.query += urlEncode("par_area",strArea);
  this.query += urlEncode("par_class",strClass);
}

function COMethod_setParam( strParamName, anyParamValue )
{
 if(typeof(anyParamValue)=="object") { /* Array */
    this.query += urlEncodeArray( "_"+strParamName, anyParamValue );
 } else {
    this.query += urlEncode( strParamName, anyParamValue );
 }
}

// usage: method.call("my_callback", 1, "name"); 
// will call: my_callback('1', 'name', o);
function COMethod_call(strCallback)
{
	var callback = strCallback+"(";
	for (var i=1; i<arguments.length; i++) {
		callback += "'"+(new String(arguments[i])).replace(/'/g, "\\'")+"',";
	}
	this.query += urlEncode("callback", callback);
    PutRequest(this.query);
}

COMethod.prototype.setParam = COMethod_setParam;
COMethod.prototype.call = COMethod_call;
