function getEventSrcElement(eventAny)
{
 var o;
 if (is_ie5up) {
    o = eventAny.srcElement;
 } else if (is_nav5up) {
    o = eventAny.originalTarget;
    event = eventAny;
 }
 return o;
}


var f_spreadsheet;
var last;

var table=null;

function getTable()
{
 if (!table) table = f_spreadsheet.getElementById("table");
 return table;
}

function show_error(strMessage)
{
  alert(strMessage);
}

function window_onload()
{
 f_spreadsheet = window.parent.frames.f_spreadsheet.document;
//document.parent.f_spreadsheet;
 document.getElementById("b_left").on = button_method_on;
 document.getElementById("b_left").off = button_method_off;
 document.getElementById("b_center").on = button_method_on;
 document.getElementById("b_center").off = button_method_off;
 document.getElementById("b_right").on = button_method_on;
 document.getElementById("b_right").off = button_method_off;
}

function set_bold(v)
{
 b_bold.style.fontWeight = v;
}

document.set
_bold = set_bold;

function set_italic(v)
{
 b_italic.style.fontStyle = v;
}

function set_underline(v)
{
 b_underline.style.textDecoration = v;
}

function bold_state()
{
 var obj_b = b_bold.style;
 if (obj_b.fontWeight<700) return "b";
 else return "B";
}

function italic_state()
{
 var obj_i = b_italic.style;
 if (obj_i.fontStyle=="") return "i";
 else return "I";
}

function underline_state()
{
 var obj_u = b_underline.style;
 if (obj_u.textDecoration=="") return "u";
 else return "U";
}

function bold_onclick()
{
 var obj_b = b_bold.style;

 if (obj_b.fontWeight<700) 
 {
  //obj.fontWeight = 700;
  //alert(underline_state());
  f_spreadsheet.textstyle_cells('B'+italic_state()+underline_state());
 }
 else 
 {
  //obj.fontWeight = 400;
  //alert(underline_state());
  f_spreadsheet.textstyle_cells('b'+italic_state()+underline_state());
 }
 b_bold.blur();
}

function italic_onclick()
{
 var obj_i = b_italic.style;

 if (obj_i.fontStyle=="") 
 {
  //obj.fontStyle = "italic";
  f_spreadsheet.textstyle_cells(bold_state()+'I'+underline_state());
 }
 else 
 {
  //obj.fontStyle = "";
  f_spreadsheet.textstyle_cells(bold_state()+'i'+underline_state());
 }
 b_italic.blur();
}

function underline_onclick()
{
 var obj_u = b_underline.style;

 if (obj_u.textDecoration=="")
 {
  //obj.textDecoration = "underline";
  f_spreadsheet.textstyle_cells(bold_state()+italic_state()+'U');
 }
 else
 {
  //obj.textDecoration = "";
  f_spreadsheet.textstyle_cells(bold_state()+italic_state()+'u');
 }
 b_underline.blur();
}

function button_activate(name)
{
 var b=document.getElementById(name);
 b.style.display="inline";
}

function button_deactivate(name)
{
 //alert("button "+name);
 var b=document.getElementById(name);
 b.style.display="none";
}

function button_on(name)
{
 var b = document.getElementById(name);
 var fn = b.getAttribute("filename");
 b.src = "/co/images/buttons_on/"+fn+".gif";
}

function button_off(name)
{
 var b = document.getElementById(name);
 var fn = b.getAttribute("filename");
 b.src = "/co/images/buttons_off/"+fn+".gif";
}

function button_method_on()
{
 var fn = this.getAttribute("filename");
 b.src = "/co/images/buttons_on/"+fn+".gif";
}

function button_method_off()
{
 var fn = this.getAttribute("filename");
 this.src = "/co/images/buttons_off/"+fn+".gif";
}

function update_align_buttons(alg)
{
 switch (alg) 
 {
  case "left":{ button_on("b_left"); button_off("b_center"); button_off("b_right"); break; }
  case "center":{ button_off("b_left"); button_on("b_center"); button_off("b_right"); break; }
  case "right":{ button_off("b_left"); button_off("b_center"); button_on("b_right"); break; }
  default:{ button_off("b_left"); button_off("b_center"); button_off("b_right"); break; }
 } 
}

var click_counter=0;

function scripts_clicked()
{
 var sp_id = par_id;
 var ob_type = "cell";
 var c_id = f_spreadsheet.cell2ColumnId(f_spreadsheet.active_cell)
;
 var r_id = f_spreadsheet.cell2RowId(f_spreadsheet.active_cell);

//alert(f_spreadsheet.getRowNumberByCell(f_spreadsheet.active_cell));
//alert("sp_id="+sp_id+" col_id="+c_id+" row_id="+r_id);
/*
 var ob_value = f_spreadsheet.current_cell_value();
*/
 if (f_spreadsheet.selection!=null)
 { 
  switch (f_spreadsheet.selection.area.type) {
    case "c":{ ob_type="column"; r_id = 0; break; }
    case "r":{  ob_type="row"; c_id = 0; break; }
    case "g":{  ob_type="spreadsheet";
 c_id = 0; r_id = 0; break;
 }
  }
 }

 //window.open("/co/spreadsheet/form_scripts.asp?active=&active_path=&object="+ob_type+"&s_id=" + ob_id +"&c_id="+c_id+"&r_id="+r_id+ "&" + f_spreadsheet.urlEncode("value", ob_value), "w_"+ob_type+ob_id+"_"+(click_counter++),"toolbar=no,menubar=no,location=no,resizable=yes,scrollbars=yes")
window.open("/co/asp/sys/spreadsheet?showCode&active=&active_path=&object="+ob_type+"&sp_id=" + sp_id +"&c_id="+c_id+"&r_id="+r_id+ "&" );//+ f_spreadsheet.urlEncode("value", ob_value), "w_"+ob_type+ob_id+"_"+(click_counter++),"toolbar=no,menubar=no,location=no,resizable=yes,scrollbars=yes")
}

function wartosc_onfocus(thisObj)
{
 thisObj.edit_mode = true;
 thisObj.mod_cell = false;
 return true;
}

function wartosc_onkeyup(thisObj) {
 getTable().updateActiveCellText(thisObj.value);
}

function wartosc_onblur(thisObj)
{
 getTable().sendActiveCellText(thisObj.value);
}

