#ifdef ADDON
#include "../../co/comodules/generic_acl/co_generic_acl.h"
#else
#include "../comodules/generic_acl/co_generic_acl.h"
#endif

     #ifndef   __CO_METHOD_PARAMS_showFormAssociation
     #define   __CO_METHOD_PARAMS_showFormAssociation

     #include "../coffice/co_array.h"

	
     typedef struct
      {
      const char* par_area; 
const char* par_class; 
int par_id; 
const char* column_first_class; 
const char* report_first_class; 
const char* column_second_class; 
const char* report_second_class; 

     }  co_typein_values_showFormAssociation; 

     typedef struct
      { int par_area; 
int par_class; 
int par_id; 
int column_first_class; 
int report_first_class; 
int column_second_class; 
int report_second_class; 

     }  co_typein_control_showFormAssociation; 
     typedef struct
      {
         int magic_par_area;
         int magic_par_class;
         int magic_par_id;

         co_typein_control_showFormAssociation * control;
         co_typein_values_showFormAssociation * values;
      } co_typein_showFormAssociation;
     
    #define __PARAM_STRUCT_CREATE_showFormAssociation(PARAM_STRUCT_NAME) \
        co_typein_showFormAssociation  * PARAM_STRUCT_NAME  = ({ \
        co_typein_showFormAssociation  * ret = ap_pcalloc(p, sizeof(co_typein_showFormAssociation)); \
        co_typein_control_showFormAssociation* control = ap_pcalloc(p, sizeof(co_typein_control_showFormAssociation)); \
        co_typein_values_showFormAssociation * values  = ap_pcalloc(p, sizeof(co_typein_values_showFormAssociation)); \
        ret->control = control; ret->values = values; ret->magic_par_id=__PARAMS_MAGIC_WITH_PAR_ID; ret->magic_par_area=__PARAMS_MAGIC_WITH_PAR_AREA;ret->magic_par_class=__PARAMS_MAGIC_WITH_PAR_CLASS;\
        ret;});

      #endif
    
     #ifndef   __CO_METHOD_PARAMS_showFormMenu
     #define   __CO_METHOD_PARAMS_showFormMenu

     #include "../coffice/co_array.h"

	
     typedef struct
      {
      const char* par_area; 
const char* par_class; 
int par_id; 
const char* menu_name; 
const char* menu_type; 

     }  co_typein_values_showFormMenu; 

     typedef struct
      { int par_area; 
int par_class; 
int par_id; 
int menu_name; 
int menu_type; 

     }  co_typein_control_showFormMenu; 
     typedef struct
      {
         int magic_par_area;
         int magic_par_class;
         int magic_par_id;

         co_typein_control_showFormMenu * control;
         co_typein_values_showFormMenu * values;
      } co_typein_showFormMenu;
     
    #define __PARAM_STRUCT_CREATE_showFormMenu(PARAM_STRUCT_NAME) \
        co_typein_showFormMenu  * PARAM_STRUCT_NAME  = ({ \
        co_typein_showFormMenu  * ret = ap_pcalloc(p, sizeof(co_typein_showFormMenu)); \
        co_typein_control_showFormMenu* control = ap_pcalloc(p, sizeof(co_typein_control_showFormMenu)); \
        co_typein_values_showFormMenu * values  = ap_pcalloc(p, sizeof(co_typein_values_showFormMenu)); \
        ret->control = control; ret->values = values; ret->magic_par_id=__PARAMS_MAGIC_WITH_PAR_ID; ret->magic_par_area=__PARAMS_MAGIC_WITH_PAR_AREA;ret->magic_par_class=__PARAMS_MAGIC_WITH_PAR_CLASS;\
        ret;});

      #endif
    
     #ifndef   __CO_METHOD_PARAMS_insertAssociations
     #define   __CO_METHOD_PARAMS_insertAssociations

     #include "../coffice/co_array.h"

	
     typedef struct
      {
      const char* par_area; 
const char* par_class; 
int par_id; 
const char* callback; 
co_array_of_pointers * ids_first_class; 
const char* prop_first_class; 
co_array_of_pointers * ids_second_class; 
const char* prop_second_class; 

     }  co_typein_values_insertAssociations; 

     typedef struct
      { int par_area; 
int par_class; 
int par_id; 
int callback; 
int ids_first_class; 
int prop_first_class; 
int ids_second_class; 
int prop_second_class; 

     }  co_typein_control_insertAssociations; 
     typedef struct
      {
         int magic_par_area;
         int magic_par_class;
         int magic_par_id;

         co_typein_control_insertAssociations * control;
         co_typein_values_insertAssociations * values;
      } co_typein_insertAssociations;
     
    #define __PARAM_STRUCT_CREATE_insertAssociations(PARAM_STRUCT_NAME) \
        co_typein_insertAssociations  * PARAM_STRUCT_NAME  = ({ \
        co_typein_insertAssociations  * ret = ap_pcalloc(p, sizeof(co_typein_insertAssociations)); \
        co_typein_control_insertAssociations* control = ap_pcalloc(p, sizeof(co_typein_control_insertAssociations)); \
        co_typein_values_insertAssociations * values  = ap_pcalloc(p, sizeof(co_typein_values_insertAssociations)); \
        ret->control = control; ret->values = values; ret->magic_par_id=__PARAMS_MAGIC_WITH_PAR_ID; ret->magic_par_area=__PARAMS_MAGIC_WITH_PAR_AREA;ret->magic_par_class=__PARAMS_MAGIC_WITH_PAR_CLASS;\
        ret;});

      #endif
    