#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class meta_param
{
   area sys
   {
       force_sec_type 1;
   };

#include "check_acl.t"

   inherits generic_acl;
   
   container_class 'meta_class';
   container_column_name 'class_name';

#include "generic_acl_props.t" 

  index in1 
  { 
    unique 0; 
    column id_method; 
    column position; 
  }; 


	prop name
	{
		type CO_STRING;
		default "''";
		params '';
		representant 100;
		foreign '';
		foreign_prop '';
		position 200;
		group_path '';
   };
 
	prop state
	{
		type CO_STRING;
		default "'NEW'";
		params '';
		representant 100;
		foreign '';
		foreign_prop '';
		position 250;
		group_path '';
   };
 
	prop id_method
	{
		type CO_INDEX;
		default "''";
		params '';
		representant 1;
		foreign 'meta_method';
		foreign_prop 'id';
		position 300;
		group_path '';
	};
   
	prop position
	{
		type CO_INTEGER;
		default 0;
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 700;
		group_path '';
	};

	prop type_name
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 800;
		group_path '';
	};

	prop attoid
	{
		type CO_INDEX;
		default 0;
		params 'READONLY=1;';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1400;
		group_path '';
	};


	uses generic;
	uses meta_class;

	method commitChange
	{
		doc "This method commits all changes done on this property to database"
		{
			pl "Ta metoda wprowadza wszystkie zrobione na tym prop zmiany do bazy danych";
		};

		id_permission __PERMISSION_UPDATE;
		sec_type __METHOD_SEC_TYPE_OBJECT;
   
		__PARAMS_HEADER
     
		declare language_c
		{
			C 'char * state;';
			C 'char * sql_type;';
			C 'char * prop_type;';
			C 'char * prop_name;';
			C 'int id_class;';
		};

		body language_c
		{
			C 
			%%
			// reading state
			%%
			; 
		};  

	}; // method commitChange


};
