// TYPES FOR CO

#include "types.t"      


// CLASS GENERIC
class generic
{ 
  inherits 0;

  "kl;sk;lsk; fd\"fdf xxxx" ' uoiuofsd""""""\'yyyy'
        
 // PROPERTIES
      
  prop id
  { 
    type int;
    default 0;
    position 0;
    params READONLY1;
  }; 
  prop deleted 
  { 
    type int;
    default 0;
  };
  prop version
  { 
    type int;
    default 0;
  };
  

// METHODS
    
  method get
  {
    param par_id { type CO_INTEGER; optional 0; };
    param callback {type CO_STRING;};
    param par_area {type CO_STRING;};
    param par_class {type CO_STRING;};
      
    body language_c
      {
         C " sprintf(SQLString, \"SELECT * FROM co_%s_%s WHERE id=%d\" , par_area, par_class,par_id);";
         C " __GET_RESULT_AND_CREATE_JS";
      };  
								    
  };


 method update
 {
    param par_area {type CO_STRING;};
    param par_class {type CO_STRING;};
    param par_id { type CO_INTEGER; };
    param par_prop { type CO_STRING; };
    param new_value { type CO_STRING; };
    param callback {type CO_STRING;};
    
    declare language_c
    {
      C "int cur_version;";
      C "char new_value_coded[FIELDBUFSIZE];";
      C "char new_value_js_encoded[FIELDBUFSIZE];";
    };  

    body language_c
    {
      C " __INIT_VARIABLES";

      C "memset(new_value_coded,0,FIELDBUFSIZE);";
      C "memset(new_value_js_encoded,0,FIELDBUFSIZE);";

      C "cou_SQLEncode(new_value,new_value_coded);";
      C "cou_JSEncode(new_value,new_value_js_encoded);";

      C 'sprintf(SQLString, "SELECT version FROM co_%s_%s WHERE id=%d ",par_area, par_class, par_id);';

      C "__SQL_GET_RESULT";
      C "cur_version= atoi(PQgetvalue(res, 0, 0));";
      C "PQclear(res);";
      C "memset(SQLString, 0, SQLBUFSIZE);";

      C 'sprintf(SQLString, "UPDATE co_%s_%s SET %s=\'%s\', version=version+1 WHERE id=%d ",';
      C '        par_area, par_class,par_prop, new_value_coded,par_id);';
      C "__SQL_EXEC";

      C 'sprintf(JSOutBuf, "var o=new Object(); o.class_name=\'%s\';\n", par_class);';
      C 'sprintf(JSOutBuf + strlen(JSOutBuf), "o.d=new Object();o.d.id=new Array();o.d.%s=new Array();\n", par_prop);';
      C 'sprintf(JSOutBuf + strlen(JSOutBuf), "o.d.id[0]='%d';o.d.%s[0]=\'%s\';\n", par_id,par_prop,new_value_js_encoded);';
      C 'sprintf(JSOutBuf + strlen(JSOutBuf), "co_refresh(o);\n");';

      C "if(cnx->putJS) cou_putJS(cnx, JSOutBuf);";
    };
   };

 method select
  {
    doc "Gets rcordset of objects on given filter rule";

    param callback {type CO_STRING; doc "this is very important parameter";};
    param par_area {type CO_STRING;};
    param par_class {type CO_STRING;};
    param get_class_names {type CO_ARRAY_OF_STRINGS;};
    param get_prop_names {type CO_ARRAY_OF_STRINGS;};
    param filter_class_names {type CO_ARRAY_OF_STRINGS;};
    param filter_prop_names {type CO_ARRAY_OF_STRINGS;};
    param filter_operators {type CO_ARRAY_OF_STRINGS;};
    param filter_values {type CO_ARRAY_OF_STRINGS;};
    
    declare language_c
    {
      C "int get_col_num, filter_col_num;";
      C "int sql_from_start,i;";
      C "char column_value_coded[FIELDBUFSIZE];";
      C "char column_value_js_encoded[FIELDBUFSIZE];";
    };
      
    body language_c
    {
      C "__INIT_VARIABLES";

      C "memset(column_value_coded,0,FIELDBUFSIZE);";
      C "memset(column_value_js_encoded,0,FIELDBUFSIZE);";

      C 'sprintf(SQLString, "SELECT ");';

      C "if(get_class_names[0])";
      C '  { sprintf(SQLString + strlen(SQLString), " co_%s_%s.%s ", par_area, get_class_names[0], get_prop_names[0]);}';
      C "i=1;";
      C "while(get_class_names[i])";
      C '{sprintf(SQLString + strlen(SQLString), " , co_%s_%s.%s ", par_area, get_class_names[i], get_prop_names[i]);';
      C " i++;};";

      C "sql_from_start = strlen(SQLString);";
      C 'sprintf(SQLString + strlen(SQLString), " FROM co_%s_%s ", par_area, get_class_names[0]);';
      C "i=1;";
      C "while(get_class_names[i])";
      C "{ /* all table names we are taking only once*/ ";
      C " if(0==strstr(SQLString+sql_from_start, get_class_names[i]))";
      C '{ sprintf(SQLString + strlen(SQLString), " , co_%s_%s ", par_area, get_class_names[i]);};';
      C "i++;};";

      C 'sprintf(SQLString + strlen(SQLString), " WHERE co_%s_%s.%s %s \'%s\' ", par_area,';
      C "              filter_class_names[0], filter_prop_names[0],filter_operators[0], filter_values[0]);";
      C "i=1;";
      C "while(filter_prop_names[i]){";
      C 'sprintf(SQLString + strlen(SQLString), " , co_%s_%s.%s %s %s ",par_area,';
      C '           filter_class_names[i], filter_prop_names[i],filter_operators[i], filter_values[i]);';
      C	"i++;};";

      C 'cou_logError( cnx, CO_LOG_DEBUG, "SELECT SQL:");';
      C 'cou_logError( cnx, CO_LOG_DEBUG, SQLString);';

      C "__GET_RESULT_AND_CREATE_JS";
    };
  };

  method getRelatedClasses
   {
       doc "rettrieves related tables names and foreign column names for given class";

     param par_area {type CO_STRING;};
     param par_class {type CO_STRING;};
       param callback {type CO_STRING;};

       body language_c
        {
          C " __INIT_VARIABLES";
          C 'sprintf(SQLString, "SELECT class_name, prop_name, prop_foreign_prop FROM co_%s_meta_prop WHERE prop_foreign=\'%s\'",';
          C "  par_area, par_class);";

          C " __GET_RESULT_AND_CREATE_JS";
       };
   };

 method getSchema
   {
      doc  "Retrieves schema for given class";

     param par_area {type CO_STRING;};
     param par_class {type CO_STRING;};
      param callback {type CO_STRING;};

      body language_c
       {
          C "__INIT_VARIABLES";

          C 'sprintf(SQLString, "SELECT * FROM co_%s_meta_prop WHERE class_name=\'%s\' ", par_area,par_class);';

          C "__GET_RESULT_AND_CREATE_JS";
       };
   };

 method showForm
   {

     param application_id {type CO_INTEGER;};
     param session_id {type CO_INTEGER;};
     param par_id {type CO_INTEGER;};
     param par_area {type CO_STRING;};
     param par_class {type CO_STRING;};

     declare language_c
      {
        C "FILE *fh;";
        C "int c;";
        C "const char* root_path;";
        C "long len;";
      };

     body language_c
      {
        C "root_path = cou_getCORootPath( cnx );";

        C 'fh = ap_pfopen(r->pool, ap_pstrcat( r->pool, root_path, "/forms/", "generic", "_head.html", NULL), "r");';
        C 'if (!fh) cou_error( cnx, "Head file not found");';
        C 'cou_logError( cnx, CO_LOG_DEBUG, "sending head" );';
        C 'ap_rputs("<HEAD>\n", r);';
        C 'ap_kill_timeout(r);';

        C 'len = ap_send_fd( fh, r ); /* returns total of bytes sent */';
        C 'ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server, "Head sent: %d bytes", len);';

        C 'ap_pfclose(r->pool,fh);';


        C 'cou_logError( cnx, CO_LOG_DEBUG, "sending script" );';
        C 'ap_rputs("<SCRIPT>\n", r);';

	C 'ap_rprintf( r, "var session_id = %d;\n", session_id );';
	C 'ap_rprintf( r, "var application_id = %d;\n", application_id );';
	C 'ap_rprintf( r, "var  par_id = %d;\n", par_id );';
	C 'ap_rprintf( r, "var  par_class=\'%s\';\n", par_class );';
	C 'ap_rprintf( r, "var  par_area = \'%s\';\n", par_area );';

        C 'ap_rputs("</SCRIPT>\n", r);';

        C 'ap_rputs("</HEAD>\n", r);';
        C 'fh = ap_pfopen(r->pool, ap_pstrcat( cnx->request->pool, root_path, "/forms/", "generic", "_body.html", NULL), "r");';
        C 'if (!fh) cou_error( cnx, "Body file not found");';
        C 'cou_logError( cnx, CO_LOG_DEBUG, "sending body" );';
        C 'ap_rputs("<BODY>\n", r);';
        C 'len = ap_send_fd( fh, r ); /* returns total of bytes sent */';

        C 'if (r->connection->aborted) ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server, "connection aborted");';
        C 'ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server, "bytes_send=%d", r->bytes_sent);';

        C 'ap_soft_timeout("finish request", r);';

        C 'ap_log_error(APLOG_MARK, APLOG_DEBUG, r->server, "Body sent: %d bytes", len);';

        C 'ap_pfclose(r->pool,fh);';
        C 'ap_rputs("</BODY>\n", r);';

        C 'ap_rflush(r);';
    };
  };

  
};

//END OF CLASS GENERIC

.



